/*
 * BOX OFFICES for iPhone/iPad
 *
 * The Original Game is Designed by Entatonic.net
 * Copyright (c) 2010 Entatonic.net
 * http://entatonic.net
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */



#import <Foundation/Foundation.h>
#import "StageManager.h"
#import "FieldManager.h"
#import "Relations.h"
#import "ScoreManager.h"

#define max_flick_count 100

@interface GameManager : NSObject {
	StageManager *m_stageManager;
	FieldManager *m_fieldManager;
	ScoreManager *m_scoreManager;
	
	double flick_line_vx;
	double flick_line_vy;
	int flick_count;
	
	BOOL gameClear;
	BOOL gameLost;
	BOOL wasFlicked;
	BOOL gamePause;		// For Game Pause
	BOOL hit;
	
	BOOL m_display_memory;
}
-(void) initStageRoundNumber;
-(void) continueStage;

-(void) resetStageforNext:(CCLayer *)spriteOwnerCocosLayer;
-(void) releaseFieldManager;

-(ScoreManager *) getScoreManager;
-(StageManager *) getStageManager;
-(FieldManager *) getFieldManager;
-(Relations *)	getRelations;

-(void) moveLauncherLeft:(CCLayer *)spriteOwnerCocosLayer;
-(void) resetLauncher:(CCLayer *) spriteOwnerCocosLayer;
-(BOOL) launchBox_vx:(float)launcher_vx vy:(float)launcher_vy;
-(BOOL) incrementStage;
-(int) getStageRound;
-(int) getLogStageNum;
-(int) getLogStageRound;
-(int) getStageNum;
-(void) stepFieldAnimation:(CCLayer *) spriteOwnerCocosLayer stageHalt:(BOOL) halt;
-(cpSpace *) getcpSpace;
-(int) getNumOfObjectsOnField;
-(int) getCeilingY;

-(void) setFlickLine_vx:(double) vx vy:(double)vy;
-(double) getFlickLine_vx;
-(double) getFlickLine_vy;
-(int) getFlickLine_count;

// Relations
-(void) setRelations:(cpShape *) shapeA withShape:(cpShape *) shapeB;
-(void) removeBoxRelation:(int) index;

// Score
-(void) resetScore;
-(void) syncScore;
-(int) getScore;
-(int) getDisplayingScore;


-(void) stepFieldAnimation:(CCLayer *) spriteOwnerCocosLayer stageHalt:(BOOL) halt;
-(boxObject *) getBoxObjectFrom_index:(int) index;
-(int) getBoxObject_Count;

-(void) setGameClear;
-(BOOL) getGameClear;
-(BOOL) getGameLost;
-(BOOL) getGameRedAlart;


-(void) setwasFlicked:(BOOL) Flicked;
-(BOOL) getwasFlicked;

-(void) setGamePause:(BOOL) Pause;
-(BOOL) getGamePause;

-(BOOL) getHit;

-(void) setDisplaMemory:(BOOL) displayMemory;
-(BOOL) getDisplaMemory;


@property (assign) StageManager *m_stageManager;
@property (assign) FieldManager *m_fieldManager;

@end
