/*
 * BOX OFFICES for iPhone/iPad
 *
 * The Original Game is Designed by Entatonic.net
 * Copyright (c) 2010 Entatonic.net
 * http://entatonic.net
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */



#import <Foundation/Foundation.h>
#import "cocos2d.h"
#import "MenuScene.h"
#import "GameManager.h"
#import "FieldManager.h"
#import "chipmunk.h"
#import "boxObject.h"
#import "MyOpenAL.h"


@interface GameScene : CCScene {
	GameManager *m_gameManager;
}

-(id) initWithGameManager: (GameManager *) gameManager;

@property (assign) GameManager *m_gameManager;
@end

@interface TitleLayer : CCLayer {
	GameManager *m_gameManager;
	NSTimeInterval countstart_time;
}

-(void)loadAudio;
-(id) initWithGameManager: (GameManager *) gameManager;
@end

@interface GameBackGroundLayer : CCLayer{
	GameManager *m_gameManager;
}
-(id) initWithGameManager: (GameManager *) gameManager;
@end

@interface GameTopTextLayer : CCLayer{
	GameManager *m_gameManager;

	int display_width;
	int display_height;
	int display_width_center;
	int display_height_center;
	int display_height_launcher_y;
	int display_score_y;
	
	int game_counter;
	float launcher_color_counter;

	int relationstagestopCounter;
	int explosionstagestopCounter;
	int autoReleaseDrawCounter;
	int autoReleaseTimes;
}

-(id) initWithGameManager: (GameManager *) gameManager;
@end

@interface GameFieldLineLayer : CCLayer{
	GameManager *m_gameManager;
	int redAlartCounter;
	
	int drawingCeilingY;
}

-(id) initWithGameManager: (GameManager *) gameManager;
@end

@interface GameLineAndStringLayer : CCLayer{
	GameManager		*m_gameManager;
	StageManager	*m_StageManager;
	ScoreManager	*m_ScoreManager;
	Relations		*m_Relations;
	int display_width;
	int display_height;
	int display_width_center;
	int display_height_center;
	int display_height_launcher_y;
	int display_score_y;

	int m_text_shadow_color_r;
	int m_text_shadow_color_g;
	int m_text_shadow_color_b;
	
	int redAlartCounter;
	int tentative_x;
	float launcher_color_counter;
	int arrow_move_counter;

	int game_counter;
}

-(id) initWithGameManager: (GameManager *) gameManager;

@end


@interface GameLayer : CCLayer{
	GameManager *m_gameManager;
	BOOL m_endFlag;
	
	BOOL isTouch;
	BOOL isFlicked;
	double flick_vx, flick_vy;
	NSMutableArray			*m_touch_x;			// touch log
	NSMutableArray			*m_touch_y;			// touch log
	NSMutableArray			*m_touch_time;		// touch log (msec)

	NSTimeInterval game_start_time_test;		// For test
	NSTimeInterval start_time_test;				// For test
	NSTimeInterval countstart_time;

	NSTimeInterval countgameover_time;			// For count after Game Over

	int display_score_y;
	
	int display_width;
}

-(void) backToMenuButton: (id)sender;
-(void) backToMenu;

-(id) initWithGameManager: (GameManager *) gameManager;
-(void) collision_detect:(cpShape *) shapeA withShape:(cpShape *) shapeB;

@property (nonatomic, retain) NSMutableArray *m_touch_x;
@property (nonatomic, retain) NSMutableArray *m_touch_y;
@property (nonatomic, retain) NSMutableArray *m_touch_time;

@end



@interface EndLayer : CCLayer {
	GameManager *m_gameManager;
}
@end
