/*
 * BOX OFFICES for iPhone/iPad
 *
 * The Original Game is Designed by Entatonic.net
 * Copyright (c) 2010 Entatonic.net
 * http://entatonic.net
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */



#import <Foundation/Foundation.h>

#define ADDINGSCORE_DISPLAYING_COUNTER_MAX 100

@interface ScoreManager : NSObject {
	int	score;
	int displayingScore;
	
	NSMutableArray			*addingScore_x;						// display addingScore x
	NSMutableArray			*addingScore_y;						// display addingScore y
	NSMutableArray			*addingScore;						// adding Score
	NSMutableArray			*addingScore_displaying;			// Dispaying adding Score
	NSMutableArray			*addingScore_displaying_counter;	// Dispaying adding Score counter
}

-(void) addScore:(int) PlusScore x:(int) score_display_x y:(int) score_display_y;
-(void) resetScore;
-(void) resetAddingScore;
-(void) syncScore;
-(int) getScore;
-(int) getDisplayingScore;
-(void) addAddingScore:(int)add_score x:(int)x y:(int)y;
-(void) removeAddingScore:(int) index;
-(int) getNumOfAddingScore;
-(int) getAddingScore_x:(int) index;
-(int) getAddingScore_y:(int) index;
-(int) getAddingScore_addingScore_displaying:(int) index;
-(int) getAddingScore_addingScore_displaying_counter:(int) index;
-(void) stepAnimation;

@property (nonatomic, retain) NSMutableArray *addingScore_x;
@property (nonatomic, retain) NSMutableArray *addingScore_y;
@property (nonatomic, retain) NSMutableArray *addingScore;
@property (nonatomic, retain) NSMutableArray *addingScore_displaying;
@property (nonatomic, retain) NSMutableArray *addingScore_displaying_counter;

@end
