/*
 * BOX OFFICES for iPhone/iPad
 *
 * The Original Game is Designed by Entatonic.net
 * Copyright (c) 2010 Entatonic.net
 * http://entatonic.net
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */



#import <Foundation/Foundation.h>
#import "iPhone_iPad_Selector.h"
#import "cocos2d.h"

@interface StageManager : NSObject {
	int			stage_loop;
	int			stage_round;	// STAGE (round)-(num)   : round 1-8
	int			stage_num;		// STAGE (round)-(num)   : num   1-4
	int			log_stage_loop;
	int			log_stage_round;
	int			log_stage_num;
	
	NSArray		*m_stageData;	// Stage Data
	int			launcher_index;	// launcher index
	
}

-(NSArray *) getStageData;
-(void) loadStageData;

-(void) resetStage;
-(void) continueStage;
-(BOOL) incrementStage;

-(int) getStageLoop;
-(int) getLogStageLoop;
-(int) getStageRound;
-(int) getLogStageNum;
-(int) getLogStageRound;
-(int) getStageNum;

// Tutorial
-(BOOL) IsTutorialStage;

// Stage Data
-(NSString *) getBoxImage:(int) index;
-(int) getBoxImageCount;
-(NSString *) getBackGournd_image;
-(NSString *) getBgm;
-(NSString *) getBgm_song_name;
-(NSString *) getBgm_artist_name;
-(int) getBgm_artist_name_position_x;
-(int) getBgm_artist_name_position_y;
-(float) getFriction;

// Stage Initial Box Data
-(int) countInitialBoxes;
-(float) get_initialBox_x:(int) index;
-(float) get_initialBox_y:(int) index;
-(int) get_initialBox_vx:(int) index;
-(int) get_initialBox_vy:(int) index;
-(int) get_initialBox_type:(int) index;
-(int) get_initialBox_scale:(int) index;
-(NSArray *) getInitialBoxArray;

#define random 0
#define loop 1
-(int) get_launcherType;						// internal.
-(int) get_launcherTypeisLoop_Count;			// internal. count of loop, if launcher type is loop
-(int) get_launcher_NextboxType;

// Text Color
-(float) getTextShadowColor:(int) index;	// 0: R, 1: G, 2: B
-(float) getFieldLineColor:(int) index;
-(float) getStageStringColor:(int) index;
-(float) getArtistNameStringColor:(int) index;
-(float) getClearStringColor:(int) index;
-(float) getGameOverStringColor:(int) index;
-(int) getCielingDown;

// ver 1.1 auto save function
- (void) loadGameData;
- (void) saveGameData;

@property (assign) int stage_round;
@property (assign) int stage_num;
@property (nonatomic, retain) NSArray			*m_stageData;

@end
