/*
 * BOX OFFICES for iPhone/iPad
 *
 * The Original Game is Designed by Entatonic.net
 * Copyright (c) 2010 Entatonic.net
 * http://entatonic.net
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 *
 */



#import <Foundation/Foundation.h>
#import "chipmunk.h"
#import "cocos2d.h"
#import "MyOpenAL.h"
#import "iPhone_iPad_Selector.h"

#define EXPLODE_SCALE 150	//%

#define SHRINK_COUNTER_INIT_VALUE 1000
#define EXPAND_REDLINE_COUNTER_INIT_VALUE 200


@interface boxObject : NSObject {
	cpSpace *m_space;
	cpShape *m_sprite_imageShape;
	CCSprite	*m_sprite_image;
	cpBody	*m_cpBody;

	int		m_layer;	// Managed by StageObjects class
	int		m_tag;		// Managed by StageObjects class
	CCLayer	*m_spriteOwnerCocosLayer;
	
	// scale Manage
	int		m_scale;					// current scale (%)
	int		m_displaying_scale;			// current Displaying scale. Follow m_scale
	int		m_space_scale;				// size on cocos space to calculate. can't replace
	
	int m_boxType;
	int m_box_x, m_box_y;
	float m_box_vx, m_box_vy;
	
	int shrink_counter;
	int expand_redline_warning_counter;
	
	NSString* m_imagePath;
	
	BOOL createdInstance;	// TRUE:  with instance(Space)      FALSE: sprite only
	BOOL inField;			// TRUE: in field(= instance)		FALSE: out of field(= on laucnher)
}


-(id) initWithX:(float) box_x y:(float)box_y 
		boxtype:(int)box_type
		  layer:(int)layer scale:(int)scale
			cpSpace:(cpSpace *) space
			imagePath:(NSString *) imagePath
			spriteOwnerCocosLayer:(CCLayer *) spriteOwnerCocosLayer
			displayingscale:(int) displayingscale;
-(void) createSprite: (NSString *) imagePath
				   x:(float) box_x y:(float) box_y;

-(void) createBoxInstance:(float)box_vx vy:(float)box_vy;
-(void) stepAnimation;
-(float) getX;
-(float) getY;
-(float) getVX;
-(float) getVY;
-(void) setXY:(float) box_x y:(float) box_y;
-(void) setVXVY:(float)box_vx vy:(float) box_vy;
-(void) setBoxScale:(int) scale;
-(void) setDisplayingScale:(int)scale;
-(void) setAngle:(float) angle;
-(float) getAngle;
-(int) getScale;
-(int) getSpaceScale;
-(BOOL) isChangingSize;
-(BOOL) createdInstance;
-(BOOL) inField;
-(int) getDisplayingScale;
-(int) getLayer;
-(int) getBoxType;
-(NSString*) getImagePath;
-(cpShape *) getShape;
-(CCLayer	*) getspriteOwnerCocosLayer;

-(BOOL) isREDLINE_Tutorial;
-(BOOL) isREDLINE;
-(void) releaseShapes;

@property (assign) int m_layer, m_tag;
@property (assign) int m_scale, m_displaying_scale, m_space_scale;
@property (assign) CCLayer *m_spriteOwnerCocosLayer;
@property (assign) cpSpace *m_space;
@property (assign) cpShape *m_sprite_imageShape;
@property (assign) CCSprite *m_sprite_image;

@end
